/*
 * (./) WindowManager.java 05/12/26 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.event;

import java.awt.Frame;
import java.awt.event.*;
import java.util.Vector;


/* a simple class to manage application frame's event
 */
public class WindowManager extends WindowAdapter {

	private Vector owners = new Vector();
	private Vector frames = new Vector();
		
	/* constructor
	 */
	public WindowManager() {;}
	
	/* add frame and frame's owner reference
	 */
	public void add( Object owner, Frame frame ) {
		owners.add( owner );
		frames.add( frame );
	}
	
	/* window closing event action
	 */
	public void windowClosing( WindowEvent we ) {
		int i = frames.indexOf( we.getSource() );
		((mmm.ui.Editor)owners.get(i)).close(); // call the owner close() method
	}
	
	/* window closed event action
	 */
	public void windowClosed( WindowEvent we ) {
		
		// forget closed projects
		int i = frames.indexOf( we.getSource() );
		if ( i!=-1 ) {
			owners.remove( i );
			frames.remove( i );
		}
		
		// close the application if no frame exists
		if ( frames.size()==0 ) {
			// reset all output
			mmm.Project.reset();
			// close LabVIEW process
			if ( System.getProperty("os.name").indexOf("Windows")!=-1 ) {
				try { Runtime.getRuntime().exec("taskkill /F /IM lv.exe /T"); } 
				catch( Exception e ) {;}
			}
			System.exit(0);
		}
	}
}
