/*
 * (./) StatusBar.java 05/11/08 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.ui;

import java.awt.BorderLayout;
import javax.swing.*;
import javax.swing.BorderFactory;

/* a basic panel including a message field and process status, 
 */
public class StatusBar extends JPanel {
	
	// define process status
	public final static int EDIT   = 0;
	public final static int RUN    = 1;
	public final static int IMPORT = 2;
	
	// ui
	private JLabel message	= new JLabel();
	private JLabel status	= new JLabel();
	
	
	/* create a new status bar
	 */
	public StatusBar() {
		
		setStatus( EDIT );
		setLayout( new BorderLayout(7, 7) );
		setBorder( BorderFactory.createEmptyBorder(6, 7, 3, 7) );
		
		// add labels
		message.setFont( Editor.FONT_PLAIN );
		status.setFont( Editor.FONT_PLAIN );
		add( message, BorderLayout.CENTER );
		add( status, BorderLayout.EAST );
		
	}

	/* display a single message
	 * @arg String, the text to be display
	 */
	public void setText( String s ) {
		message.setText(s);
	}
	
	/* set visually the current process status
	 * @arg int, the process mode
	 */
	public void setStatus( int mode ) {
		
		String text		= "";
		ImageIcon icon	= null;
		
		switch( mode ) {
			case EDIT :
				text = "edit mode";
				icon = Resource.getIcon( "edit.png");
				break;
			case RUN :
				text = "play mode";
				icon = Resource.getIcon( "run.png");
				break;
			case IMPORT :
				text = "import...";
				icon = Resource.getIcon( "import.png");
				break;
		}
		
		status.setText( text );
		status.setIcon( icon );
	}
}
