/*
 * (./) BooleanCellEditor.java 05/11/14 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.ui.manager;

import java.awt.Component;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.*;
import javax.swing.table.TableCellEditor;


/* the Boolean cell editor
 * a 'transparent' button
 */
public class BooleanCellEditor extends AbstractCellEditor 
implements TableCellEditor, ActionListener {
	
    private JButton button;
	private boolean status;
	
	/* init button
	 */
	public BooleanCellEditor() {
		button = new JButton();
		button.addActionListener( this );
		button.setBorderPainted( false );
	}
	
	/* stop editing
	 */
    public void actionPerformed( ActionEvent e ) {
        fireEditingStopped();
    }
	
	/* return non-status value
	 */
	public Object getCellEditorValue() {
		return new Boolean( !status );
    }
	
	/* return the new cell component
	 * @arg JTable, the current JTable
	 * @arg Object, the value of the cell to be rendered
	 * @arg boolean, is the cell selected
	 * @arg int, the row index
	 * @ar int, the column index
	 */
	public Component getTableCellEditorComponent
	(JTable t, Object obj, boolean sel, int row, int column) {
		
		status = ((Boolean)obj).booleanValue();
		button.setBackground( t.getSelectionBackground() );
		
        // return component
        return button;
    }
}
