/*
 * (./) BooleanCellRenderer.java 05/12/27 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.ui.manager;

import java.awt.Component;

import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import mmm.ui.Editor;


/* the Boolean cell renderer
*/
abstract class BooleanCellRenderer extends DefaultCellRenderer 
implements TableCellRenderer {
	
	private ImageIcon icon;
	private String[] tips;
	
	/* init properties
	 * @arg String, the button icon
	 * @arg String[], the tips text to be display
	 */
	public BooleanCellRenderer( ImageIcon icon, String[] tips ) {
		this.icon = icon;
		this.tips = tips;
	}
	
	/* return the new cell component
	 * @arg JTable, the current JTable
	 * @arg Object, the value of the cell to be rendered
	 * @arg boolean, is the cell selected
	 * @arg boolean, have the focus
	 * @arg int, the row index
	 * @ar int, the column index
	 */
	public Component getTableCellRendererComponent
		(JTable t, Object obj, boolean sel, boolean hF, int row, int col ) {
			
			String name		= t.getModel().getValueAt(row, 4).toString();
			boolean status	= ((Boolean)obj).booleanValue();
			
			setIcon( status ? icon : null );
			setToolTipText( tips[ (!status ? 0:1) ].replaceAll("%s", name) );
			
			super.getTableCellRendererComponent(t, obj, sel, hF, row, col);
			return this;
		}
}
