/*
 * (./) ColorCellEditor.java 05/12/27 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.ui.manager;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.*;
import javax.swing.table.TableCellEditor;

/* the Color cell editor
*/
public class ColorCellEditor extends AbstractCellEditor
implements TableCellEditor, ActionListener {
	
    private Color color;
    private JButton button			= new JButton();
    private JColorChooser chooser	= new JColorChooser();
    private JDialog dialog;
	
	/* set up  the editor
	 */
    public ColorCellEditor( Color bkg ) {
        
		// button
        button.setActionCommand( "select" );
        button.addActionListener( this );
		button.setBorder( BorderFactory.createLineBorder( bkg, 3 ));
		
		// color chooser
		chooser.setPreviewPanel( null );
        dialog = JColorChooser.createDialog(
					button, "Select Your Color", true, chooser, this, null);
    }
	
    /* handles events
	 */
    public void actionPerformed( ActionEvent e ) {
        if ( e.getActionCommand().equals("select") ) {	// shwo the dialog
            button.setBackground( color );
            chooser.setColor( color );
            dialog.setVisible( true );
            fireEditingStopped();
		} else color = chooser.getColor();				// set the new color
    }
	
    /* return Color value
	 */
    public Object getCellEditorValue() {
        return color;
    }
	
	/* return the button component
	 * @arg JTable, the current JTable
	 * @arg Object, the value of the cell to be rendered
	 * @arg boolean, is the cell selected
	 * @arg int, the row index
	 * @ar int, the column index
	 */
	public Component getTableCellEditorComponent
		(JTable t, Object obj, boolean sel, int row, int column) {
			color = (Color) obj;
			return button;
		}
}
