/*
 * (./) DefaultCellRenderer.java 05/12/27 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.ui.manager;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import mmm.ui.TrackManager;

/* the base cell renderer : draw alternativly a colored background 
* (use by all cell renderer) 
*/
abstract class DefaultCellRenderer extends JLabel implements TableCellRenderer {
	
	/* return the new cell component
	 * @arg JTable, the current JTable
	 * @arg Object, the value of the cell to be rendered
	 * @arg boolean, is the cell selected
	 * @arg boolean, have the focus
	 * @arg int, the row index
	 * @ar int, the column index
	 */
	public Component getTableCellRendererComponent
	(JTable t, Object obj, boolean sel, boolean hF, int row, int col ) {
		
		Color bkg = (row%2!=0) ? TrackManager.ALTERNATE_BKG_COLOR : 
								 t.getBackground();
		
		setOpaque( true );
		setEnabled( t.isEnabled() );
		setBorder( BorderFactory.createEmptyBorder(0, 5, 0, 0) );
		setForeground( sel ? t.getSelectionForeground() : t.getForeground() );
		setBackground( sel ? t.getSelectionBackground() : bkg );
		
		// return component
		return this;
	}
}

